/*======================================================================*\
|| #################################################################### ||
|| # Copyright 2006-2011 Youjoomla.com. All Rights Reserved.           ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/
/**
 * YJ Newslider5 2.0
 * @version		2.0.2
 * @MooTools version 1.3, 1.4
 * @author		Constantin Boiangiu <info [at] constantinb.com>
 * Copyright Youjoomla.com
 */
var SlideShow5 = new Class({
    initialize: function (options) {
        this.options = Object.extend({
            container: 'SlideShow5',
            slidesClass: 'SlideShowSlide5',
            effectDuration: 1000,
            autoSlide: 3000,
            stopOnClick: false,
            transition: Fx.Transitions.Sine.easeOut,
            nav: 'fade',
            // values: fade, slide
            navigation: true
        }, options || {});
        this.container = $(this.options.container);
        this.start();
    },

    start: function () {
        this.navContainer = new Element('div').set({
            'class': 'navContainer5'
        }).inject(this.container);
        this.elements = this.container.getElements('.' + this.options.slidesClass);
        this.currentSlide = 0;
        this.state = 2; // 0-stopped; 1-paused; 2-playing; default, the slider is playing
        if (this.options.nav == 'slide') {
            this.scrollFx = new Fx.Scroll('SlideShowScroll5', {
                wait: false,
                duration: this.options.effectDuration,
                transition: this.options.transition
            });
        }

        this.elements.each(function (element, i) {

            if (this.options.nav == 'fade') {
                var fx = new Fx.Morph(element, {
                    duration: this.options.effectDuration,
                    wait: false,
                    transition: this.options.transition
                });
				element.setStyle('opacity',i > 0 ? 0 : 1);
				element.setStyle('position','absolute');
                this.elements[i]['fx'] = fx;
            }

            var img = element.getElement('img');
            var url = element.getElement('a');
            var link = new Element('a').set({
                'href': '#',
                'class': i == 0 ? 'selected' : 'navigation'
            }).inject(this.navContainer);
            this.elements[i]['navigation'] = link;
            new Element('img').set({
                'src': img.src,
                'align': 'left',
                'hspace': 5,
                'vspace': 5
            }).inject(link);
            new Element('span').set({
                'class': 'title'
            }).set('html',url.title).inject(link);
            new Element('br').inject(link);
            new Element('span').set({
                'class': 'description'
            }).set('html',img.alt).inject(link);

            link.addEvent('click', function (event) {
                event.stop();
                clearTimeout(this.period);
                this.switchSlide(i);
                if (!this.options.stopOnClick) this.period = this.startRotation();
                if (this.state == 1) {
                    this.play.set('html','pause');
                    this.state = 2;
                }
            }.bind(this));
        }.bind(this));
        this.period = this.startRotation();
        if (this.options.navigation) {
            this.setNavigation();
        }
    },

    setNavigation: function () {
        var controlsContainer = new Element('div').set({
            'class': 'controlsContainer5'
        }).inject(this.container);
        var back = new Element('a').set({
            'href': '#'
        }).set({
            'class': 'slide5prev'
        }).set('html','').inject(controlsContainer);
        this.play = new Element('a').set({
            'href': '#'
        }).set('html','').inject(controlsContainer);
        this.stop = new Element('a').set({
            'href': '#'
        }).set('html','').inject(controlsContainer);
        var forward = new Element('a').set({
            'href': '#'
        }).set({
            'class': 'slide5next'
        }).set('html','').inject(controlsContainer);

        this.stop.addEvent('click', function (event) {
            event.stop();
            clearTimeout(this.period);
            this.options.stopOnClick = true;
            if (this.state !== 0) this.switchSlide(0);
            this.state = 0;
            this.stop.setHTML('stopped');
            this.play.setHTML('play');
        }.bind(this));

        this.play.addEvent('click', function (event) {
            event.stop();
            if (this.state !== 2) {
                this.period = this.startRotation();
                this.state = 2;
                this.stop.setHTML('stop');
                this.play.setHTML('pause');
            } else if (this.state == 2) {
                this.state = 1;
                clearTimeout(this.period);
                this.play.setHTML('play');
            }
        }.bind(this));

        back.addEvent('click', function (event) {
            event.stop();
            clearTimeout(this.period);
            slide = this.currentSlide > 0 ? this.currentSlide - 1 : this.elements.length - 1;
            this.switchSlide(slide);
            if (this.state !== 0) this.period = this.startRotation();
        }.bind(this));

        forward.addEvent('click', function (event) {
            event.stop();
            clearTimeout(this.period);
            slide = this.currentSlide < this.elements.length - 1 ? this.currentSlide + 1 : 0;
            this.switchSlide(slide);
            if (this.state !== 0) this.period = this.startRotation();
        }.bind(this));
    },

    startRotation: function () {
        return this.rotate.periodical(this.options.autoSlide + this.options.effectDuration, this);
    },

    rotate: function () {
        slide = this.currentSlide < this.elements.length - 1 ? this.currentSlide + 1 : 0;
        this.switchSlide(slide);
    },

    switchSlide: function (slide) {
        if (this.options.nav == 'fade') {
            this.elements[this.currentSlide].tween('opacity', [1, 0]);
            this.elements[slide].tween('opacity', [0, 1]);
        } else if (this.options.nav == 'slide') {
            this.scrollFx.toElement(this.elements[slide]);

        }

        this.elements[slide]['navigation'].removeClass('navigation').addClass('selected');
        this.elements[this.currentSlide]['navigation'].removeClass('selected').addClass('navigation');
        this.currentSlide = slide;
    }
});